----COLOR-----
red = Color.new(255,0,0)
white = Color.new(255,255,255)
orange = Color.new(213,142,40)
---------player loading--------

player1 = Image.load("sprites/right1.png")
player2 = Image.load("sprites/right2.png")
player3 = Image.load("sprites/left1.png")
player4 = Image.load("sprites/left2.png")
morphball  = Image.load("Other Loading/morphball.png")

playerL = Image.load("sprites/left1.png")
playerL2 = Image.load("sprites/left2.png")
playerL3 = Image.load("sprites/left3.png")
playerL4 = Image.load("sprites/left4.png")
playerL5 = Image.load("sprites/left5.png")
playerR = Image.load("sprites/right1.png")
playerR2 = Image.load("sprites/right2.png")
playerR3 = Image.load("sprites/right3.png")
playerR4 = Image.load("sprites/right4.png")
playerR5 = Image.load("sprites/right5.png")
--------enemy image loading-------
SP1 = Image.load("sprites/sp1.png")
SPL1 = Image.load("sprites/spL1.png")
SPD = Image.load("sprites/spd.png")
-------backgound and other loading---

background = Image.load("backgrounds/background.png")
background2 = Image.load("backgrounds/2.png")
bullet = Image.load("Other Loading/bullet.png")
bullet1 = Image.load("Other Loading/bullet1.png")
missle = Image.load("Other Loading/missle.png")
missle1 = Image.load("Other Loading/missle1.png")

----player properties----

player = {}
player.img= player1
player.health = 99
player.gravity = 190
playerWidth = 35
playerHeight = 50
player.y = 110
player.x = 20
player.jumpspeed = 10
player.direction = 2
player.jumpstate = "ground"
player.standstate = "standing"

---------enemy array---------

Enemy = {}
Enemy.x = 300
Enemy.y = 100
Enemy.img = SP1
Enemy.alive = true
Enemy.jumpstate = "ground"
Enemy.gravity = 190
Enemy.jumpspeed = 10
--------music properties--------
Music.playFile("music/ingame.it", true)
Music.volume(128)



------New Block for collision---------
block = Image.createEmpty(3,200)
Block = {}
Block[1] = { x = 0, y = 100, height = block:height(), width = block:width() }

--------collision check
function collisionCheck(object)
if (player.x + playerWidth > object.x) and (player.x < object.x + object.width) and (player.y + playerHeight > object.y) and (player.y < object.y + object.height) then
player.x = 5
player.y = oldy
end
end

math.randomseed(os.time())


healthbar = {}
healthbar.y = 10



timerL = 0
timerR = 0

-- create character animation sets --

characterL = playerL
characterR = playerR

-- assign starting player --

character = characterR



--Create Array for Bullets
BulletInfo = {}
for a = 1,5 do
BulletInfo[a] = { pic = bullet , firing = false, direction = "right", x = player.x + 32,
y = player.y - 7 }
end


currentBullet = 1



----bullet setup------
function bulletSetup(direction)
if direction == "left" then
BulletInfo[currentBullet].x = player.x
BulletInfo[currentBullet].y = player.y - 7
end
if direction == "right" then
BulletInfo[currentBullet].x = player.x + 32
BulletInfo[currentBullet].y = player.y - 7
end

BulletInfo[currentBullet].direction = direction
BulletInfo[currentBullet].firing = true
end


-------bullet fire---------
function bulletFire()
for i = 1,5 do
if BulletInfo[i].firing == true then
if BulletInfo[i].direction == "right" then BulletInfo[i].x = BulletInfo[i].x + 10 end
if BulletInfo[i].direction == "left" then BulletInfo[i].x = BulletInfo[i].x - 10 end
if BulletInfo[i].direction == "up" then BulletInfo[i].y = BulletInfo[i].y - 10 end
if BulletInfo[i].direction == "down" then BulletInfo[i].y = BulletInfo[i].y + 10 end
screen:blit(BulletInfo[i].x,BulletInfo[i].y,BulletInfo[i].pic)
end
if BulletInfo[i].x < 0 or BulletInfo[i].x > 480 or BulletInfo[i].y < 0 or BulletInfo[i].y > 272 then
BulletInfo[i].firing = false
end
end






--Increase the current bullet by one, or reset it to 1
if currentBullet < 5 then
currentBullet = currentBullet + 1
else
currentBullet = 1
end
end

-------enemy chase(provided by bornxbomber-------------
function chasePlayer()
stallchase = math.random(2)
if stallchase == 1 then
if Enemy.x > player.x then
Enemy.x = Enemy.x - 2
elseif Enemy.x < player.x then
Enemy.x = Enemy.x + 2
end
end
stallchase = math.random(2)
if stallchase == 1 then
if Enemy.y > player.y then
Enemy.y = Enemy.y - 2
elseif Enemy.y < player.y then
Enemy.y = Enemy.y + 2
if Enemy.x + 2 then
Enemy.direction = 2
end
end
end
end


playerdirection = "right"

function move()

rand=math.random(1,2)


if pad:left() and rand==1 and player.standstate == "standing" then
player.x= player.x -3
player.img= player3
playerdirection = "left"
end
 
if pad:left() and rand==2 and player.standstate == "standing" then
player.x= player.x -3
player.img= player4
playerdirection = "left"
end
 
if pad:right() and rand==1 and player.standstate == "standing" then
player.x=player.x +3
player.img= player1
playerdirection = "right"
end
 
if pad:right() and rand==2 and player.standstate == "standing" then
player.x= player.x +3
player.img= player2
playerdirection = "right"
end
end
pad = Controls.read()
oldpad = pad



while true do
oldpad = pad
pad = Controls.read()
screen:clear()

move()

if ((BulletInfo[1].x or BulletInfo[2].x or BulletInfo[3].x or BulletInfo[4].x or BulletInfo[5].x) == Enemy.x) then
Enemy.img:clear()
Enemy.img = SPD
Enemy.alive = false
end

if pad:right() then
player.direction = 2
end

if pad:left() then
player.direction = 1
end

if Enemy.x < player.x then
Enemy.direction = 2
end

if Enemy.x > player.x then
Enemy.direction = 1
end

if Enemy.direction==1 then
Enemy.img = SP1
end

if Enemy.direction==2 then
Enemy.img = SPL1
end

screen:blit(0,0,background,false)
screen:fillRect(10,10,player.health,healthbar.y,red)
screen:print(10,30,player.health,orange)

if pad:cross() and player.jumpstate == "ground" then
player.jumpstate = "jumping"
end

if pad:circle() and oldpad:circle() ~= pad:circle() then
bulletSetup(playerdirection)
end

if pad:select() then
screen:save("screenshot.png")
end

if pad:down() and player.jumpstate == "ground" and player.standstate == "standing" then
player.img = morphball
player.standstate = "ball"
end
if pad:up() and player.img == morphball and player.standstate == "ball" then
player.img = player1
player.standstate = "standing"
end

if pad:circle() and oldpad:circle() ~= pad:circle() then
BulletInfo[currentBullet].pic = bullet
bulletSetup(playerdirection)
end

if pad:circle() and oldpad:circle() ~= pad:circle() and player.direction==1 then
BulletInfo[currentBullet].pic = bullet1
bulletSetup(playerdirection)
end

if pad:square() and oldpad:square() ~= pad:square() and player.direction==1 then
BulletInfo[currentBullet].pic = missle1
bulletSetup(playerdirection)
end

if pad:square() and oldpad:square() ~= pad:square() then
BulletInfo[currentBullet].pic = missle
bulletSetup(playerdirection)
end

if pad:right() and player.img == morphball then
player.x=player.x+4
end

if pad:left() and player.img == morphball then
player.x=player.x-4
end

-- set the timer for the left animation to reset at 50 --

if timerL == 50 then timerL = 0 end

-- and change the image (using the variable for each --

-- change when less then 10 --
if timerL <= 10 then characterL = playerL end

-- direction when time is over 10 --
if timerL >= 10 then characterL = playerL2 end

-- change when numbers are hit --
if timerL >= 20 then characterL = playerL3 end

if timerL >= 30 then characterL = playerL4 end

if timerL >= 40 then characterL = playerL5 end



-- other animation directions --

if timerR == 50 then timerR = 0 end
if timerR <= 10 then characterR = playerR end
if timerR >= 10 then characterR = playerR2 end
if timerR >= 20 then characterR = playerR3 end
if timerR >= 30 then characterR = playerR4 end
if timerR >= 40 then characterR = playerR5 end


if pad:r() and player.health > 0 then
player.health = player.health - 10.0
end

if player.health <= 0 then
screen:clear()
dofile("gameover.lua")
end

if pad:start() then
screen:clear()
dofile("pause.lua")
end

if player.x >= 440 then
screen:clear()
dofile("script2.lua")
end


if player.jumpstate == "jumping" then
player.jumpspeed = player.jumpspeed - 0.5
player.gravity = player.gravity - player.jumpspeed
end

if player.gravity < 0 then
player.jumpstate = "falling"
end

if player.gravity < 190 and player.jumpstate == "falling" then
player.gravity = player.gravity + (player.jumpspeed + 3)
end

-- store player's position at beginning of each loop
oldx = player.x
oldy = player.y

--paste all 3 blocks to screen
screen:blit(Block[1].x,Block[1].y,block)

--check collision for each block
collisionCheck(Block[1])

if player.gravity == 190 then
player.jumpspeed = 10
player.jumpstate = "ground"
end

if player.gravity > 190 then player.gravity = 230 end
player.y = player.gravity

if Enemy.jumpstate == "jumping" then
Enemy.jumpspeed = Enemy.jumpspeed - 0.5
Enemy.gravity = Enemy.gravity - Enemy.jumpspeed
end

if Enemy.gravity < 0 then
Enemy.jumpstate = "falling"
end

if Enemy.gravity < 190 and Enemy.jumpstate == "falling" then
Enemy.gravity = Enemy.gravity + (Enemy.jumpspeed + 3)
end

if Enemy.gravity == 190 then
Enemy.jumpspeed = 10
Enemy.jumpstate = "ground"
end

if Enemy.gravity > 190 then Enemy.gravity = 230 end
Enemy.y = Enemy.gravity

-------print player to screen---------
screen:blit(player.x, player.y, player.img)

-------print space pirate(enemy)to screen--------
screen:blit(Enemy.x, Enemy.y, Enemy.img)

if Enemy.alive==true then
chasePlayer()
end

if Enemy.alive==false then
Enemy.img:clear()
end
----------start some functions-----------

bulletFire()

screen.waitVblankStart()
screen.flip()
oldpad = pad
end